/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : gVector.cc                                               */
/*                                                                       */
/*       Date : April   , 1998                                           */
/* Updated at : April 22, 1998                                           */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#include <iostream.h>
#include "gVector.h"

/*
//
*/

template<class T1>
gVector<T1>::gVector()
{      data = NULL;
   capacity = 0;
      index = 0;
  currentCapacity = 0;
  gRate = 0.1;
}// end of default constructor

/*
//
*/

template<class T1>
gVector<T1>::gVector(unsigned _capacity)
{      data = new T1[_capacity];
   currentCapacity = capacity = _capacity;
      index = 0;
      gRate = 0.1;
}// end of default constructor

/*
// Copy constructor
*/

template<class T1>
gVector<T1>::gVector(const  gVector<T1>& RHS)
{ copyFrom(RHS); }

/*
//
*/

template<class T1>
gVector<T1>::~gVector()
{
  if(index) delete [] data;
  currentCapacity = capacity = 0;
     index = 0;
  data = NULL;
}// end of Destructor

/*
// 
*/

template<class T1>
void gVector<T1>::adjustTo(unsigned newSize )
{
   int retCode = 0;

   currentCapacity = newSize;

   T1 *temp = new T1[currentCapacity];

   for(unsigned i=0;i<index;i++) temp[i] = data[i];

   if(index) delete [] data;

   data = temp ;

}// end of adjustTo

/*
// Adds the given object
*/

template<class T1>
gVector<T1>::addElement(T1 _newElement)
{
   int retCode = 0;

   if(index<currentCapacity) 
   {  data[index] = _newElement;
      index++;
      retCode = 1;
   }
   else
    {

      adjustTo(index + maximum(1,gRate*currentCapacity));
      data[index] = _newElement;
      index++;

      retCode = 1;

    }

   return retCode;

}// end of addElement

/*
// Adds the given object
*/

template<class T1>
gVector<T1>::addElementFront(T1 _newElement)
{
   int retCode = 0;
   int i;

   if(index>=currentCapacity) adjustTo(index + maximum(1,gRate*currentCapacity));
   for(i=index;i>0;i--) data[i] = data[i-1];
   data[0] = _newElement;
   index++;
   retCode = 1;

   /*
   if(index<currentCapacity) 
   {  
      for(i=index;i>0;i--) data[i] = data[i-1];
      data[0] = _newElement;
      index++;
      retCode = 1;
   }
   else
    {

      adjustTo(index + maximum(1,gRate*currentCapacity));
      for(i=index;i>0;i--) data[i] = data[i-1];
      data[0] = _newElement;

      index++;

      retCode = 1;

    }
    */

   return retCode;

}// end of addElement

/*
// Gets the pointer of indexed object.
// If we can not find it, then it will return
// NULL.
*/

template<class T1>
T1 *gVector<T1>::getElement(unsigned indx) const
{
   T1 *ret = NULL;

   //if(indx>=0 && indx<index) ret = new T1(data[indx]);
   if(indx>=0 && indx<index) ret = &data[indx];

   return ret;

}// end of getElement()

/*
// Removes the given object from the Vector
*/

template<class T1>
gVector<T1>::removeElement(T1 removeItem)
{
   unsigned i = 0;
   int found = 0;
   int retCode = 0;

   while( !found && i<index)
   {
     if(data[i] == removeItem) retCode = removeElementAt(i);

     i++;

   }// end of while

   return retCode;

}//  end of removeElement()


/*
// Removes the given indexed object from the Vector
*/

template<class T1>
gVector<T1>::removeElementAt(unsigned indx)
{
   int retCode = 0;

   if(indx>=0 && indx<index)
   {
     // Shift the elements left

     for(unsigned j=indx+1;j<index;j++) data[j-1] = data[j];
     
     // Decrement the current pointer

     index--;

     // Adjust the Capacity of the Vector occationally

     //if((currentCapacity-index)>9 && index>capacity)
     if(( currentCapacity-index)>(maximum(9,2*gRate*currentCapacity)) && 
	  index>capacity)
     {
	/*
	//T1 *temp = new T1[index+5];
	currentCapacity = currentCapacity - maximum(1,gRate*currentCapacity);

	T1 *temp = new T1[currentCapacity];

	for(unsigned i=0;i<index;i++) temp[i] = data[i];

	if(index) delete [] data;

	data = temp;

	//currentCapacity = index+5;
	*/ 

        adjustTo( currentCapacity - maximum(1,gRate*currentCapacity) );

     }// end of if

     retCode = 1;

   }// end of if

   return retCode;

}// end of removeElementAt()

/*
//
*/

template<class T1>
gVector<T1> gVector<T1>::operator=(const gVector<T1>& RHS)
{
   dispose();
   copyFrom(RHS);

   return (*this);
}// end of operator=()

/*
// Compares two Vector Objects. Their index, capacity and
// each element should be equal. Equaliy test does not look
// this collection as a set.
*/

template<class T1>
gVector<T1>::operator==(const gVector<T1>& RHS)
{
   int ret = ( index == RHS.index ) && ( capacity == RHS.capacity ); 
   unsigned i = 0;

   ret = ret && ( currentCapacity == RHS.currentCapacity );

   while( ret && i<capacity )
   {  ret = ( data[i] == RHS.data[i] ); 
      i++;
   }// end of while

   return ret;

}// end of operator==()


/*
//
*/

template<class T1>
ostream & operator<<(ostream& os,const gVector<T1>& RHS)
{
   RHS.pritnMe(os);
   return os;

}// end of operator<<()

/*
//
*/

template<class T1>
void gVector<T1>::printMe(ostream& os) const
{
  os << " Number of Elements : "<< index << endl;
  for(unsigned i=0;i<index;i++) os << data[i] << " ";
  os << endl;

}// end of  printMe()

/*
//
*/

template<class T1>
unsigned gVector<T1>::getSize() const
{ return index; }

/*
//
*/

template<class T1>
void gVector<T1>::dispose() 
{
  if(index) delete [] data;
  index = 0;
  data  = NULL;
  if(capacity) data = new T1[capacity];
  currentCapacity = capacity;

}// end of dispose()

/*
//
*/

template<class T1>
void gVector<T1>::copyFrom(const gVector<T1>& RHS)
{
   capacity = RHS.capacity;
   currentCapacity = RHS.currentCapacity;
   index = RHS.index;

   data  = new T1[RHS.currentCapacity];

   for(unsigned i=0;i<index;i++) data[i] = RHS.data[i];

}// end of copyFrom() 

/*
*/

template<class T1>
void gVector<T1>::swap(int indx1, int indx2 ) 
{
   T1 temp ;

   if(indx1>=0 && indx1<index && indx2>=0 && indx2<index) 
   {
	temp = data[indx1];
	data[indx1] = data[indx2];
	data[indx2] = temp;

   }// end of if

}// end of swap()



